#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <iostream>
#include <string.h>

#define MODEMDEVICE "/dev/ttyS0"
#define BAUDRATE B9600

using namespace std;

int main() {
    int fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY | O_NDELAY);
    if (!fd) {
	cerr << "Cannot open port " << MODEMDEVICE << endl;
	return 1;
    }
    struct termios serialOpt;
    bzero(&serialOpt, sizeof(serialOpt));
    serialOpt.c_cflag = CS8 | CLOCAL | CREAD;
    serialOpt.c_iflag = 0;
    serialOpt.c_oflag = 0;
    serialOpt.c_lflag = 0;
    serialOpt.c_cc[VTIME]    = 0;   /* inter-character timer unused */
    serialOpt.c_cc[VMIN]     = 1;   /* blocking read until 1 character received */
    cfsetispeed(&serialOpt, BAUDRATE);
    cfsetospeed(&serialOpt, BAUDRATE);
    tcflush(fd, TCIFLUSH);
    tcsetattr(fd, TCSANOW, &serialOpt);
    char buf[1];
    while(1) {
        string i;
        cin >> i;
        if (i.compare("on")==0) buf[0] = 'a'; 
        if (i.compare("off")==0) buf[0] = 'b';
	if (i.compare("q")==0) {
    	    break;
        }
        write(fd, buf, 1);
        read(fd, buf, 1);
        cout << buf[0] << endl;
    }
    close(fd);
    return 0;
}
