#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <sys/signal.h>
#include <unistd.h>
#include <string.h>
#include <iostream>

#define SERIAL_PORT "/dev/ttyS0"
#define BAUDRATE B9600

using namespace std;

void signal_handler_IO (int status);

int newData = 0;

int main() {
    int fd = open(SERIAL_PORT, O_RDWR | O_NOCTTY);
    if (!fd) {
        cerr << "Cannot open port " << MODEMDEVICE << endl;
        return 1;
    }
    struct sigaction saio;
    saio.sa_handler = signal_handler_IO;
    sigemptyset(&saio.sa_mask);
    saio.sa_flags = 0;
    sigaction(SIGIO, &saio, NULL);
    fcntl(fd, F_SETOWN, getpid());
    fcntl(fd, F_SETFL, FASYNC);
    
    struct termios newtio;
    bzero(&newtio, sizeof(newtio));
    newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
    newtio.c_iflag = 0;
    newtio.c_oflag = 0;
    newtio.c_lflag = 0;
    newtio.c_cc[VTIME] = 0;
    newtio.c_cc[VMIN] = 1;
    tcflush(fd, TCIFLUSH);
    tcsetattr(fd, TCSANOW, &newtio);
    
    char buf[] = {'a'};
    write(fd, buf, 1);
    while(buf[0]!='N'){
	if(newData) {
	    newData = 0;
	    read(fd, buf, 1);
	    printf("%c\n", buf[0]);
        }
        // some operations
    }
    close(fd);
    return 0;
}

void signal_handler_IO (int status) {
    printf("SIGIO signal received.\n");
    newData = 1;
}
