#include <fcntl.h>
#include <termios.h>
#include <pthread.h>
#include <string.h>
#include <iostream>

#define SERIAL_PORT "/dev/ttyS0"
#define BAUDRATE B9600

using namespace std;

void * readThread(void * threadId);

int fd;

int main() {
    fd = open(SERIAL_PORT, O_RDWR | O_NOCTTY);
    if (!fd) {
        cerr << "Cannot open port " << MODEMDEVICE << endl;
        return 1;
    }
    struct termios newtio;
    bzero(&newtio, sizeof(newtio));
    newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
    newtio.c_iflag = 0;
    newtio.c_oflag = 0;
    newtio.c_lflag = 0;
    newtio.c_cc[VTIME] = 0;
    newtio.c_cc[VMIN] = 1;
    tcflush(fd, TCIFLUSH);
    tcsetattr(fd, TCSANOW, &newtio);
    
    pthread_t thread;
    pthread_create(&thread, NULL, readThread, (void *)0);
    
    while(1){
	char buf[1];
	string s;
	cin >> s;
	if (s.compare("on")==0) buf[0] = 'a';
        if (s.compare("off")==0) buf[0] = 'b';
        if (s.compare("q")==0) {
	    break;
	}
	write(fd, buf, 1);
    }
    close(fd);
    return 0;
}

void * readThread(void * threadId)
{
    char buf[1];
    while(1) {
	read(fd, buf, 1);
	cout << buf[0] << endl;
    }
}
